Bug 1302003 - Review Request: mongo-java-driver2 - MongoDB Java driver
Review Request: mongo-java-driver2 - MongoDB Java driver
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Christos Triantafyllidis
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1221474
  Show dependency treegraph
 
Reported: 2016-01-26 09:05 EST by gil cattaneo
Modified: 2016-01-29 11:02 EST (History)
6 users (show)

See Also:
Fixed In Version: mongo-java-driver2-2.14.1-1.fc24
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-29 11:02:14 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
christos.triantafyllidis: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2016-01-26 09:05:33 EST
Spec URL: https://gil.fedorapeople.org/mongo-java-driver2.spec
SRPM URL: https://gil.fedorapeople.org/mongo-java-driver2-2.14.1-1.fc23.src.rpm
Description:
Java libraries to connect to the MongoDB document database.

This package provides a new core library upon which both the
MongoDB Driver and Async Driver are both built. Users can use the
new core library to build alternative or experimental high-level APIs.
Fedora Account System Username: gil

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=12690013
Comment 1 Upstream Release Monitoring 2016-01-26 11:07:11 EST
gil's scratch build of mongo-java-driver2-2.14.1-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12691002
Comment 2 Christos Triantafyllidis 2016-01-27 16:03:34 EST
Hello Gil,

How does that relate to:
https://apps.fedoraproject.org/packages/mongo-java-driver

My understanding is that this is just an update to it. Is that correct?

In that case I think the best approach is to reach the maintainer(s) of mongo-java-driver package to discuss possible upgrade paths.

Cheers,
Christos
Comment 3 gil cattaneo 2016-01-27 16:29:24 EST
(In reply to Christos Triantafyllidis from comment #2)
> Hello Gil,
> 
> How does that relate to:
> https://apps.fedoraproject.org/packages/mongo-java-driver
> 
> My understanding is that this is just an update to it. Is that correct?
> 
> In that case I think the best approach is to reach the maintainer(s) of
> mongo-java-driver package to discuss possible upgrade paths.
> 
> Cheers,
> Christos

Soon mongo-java-driver shoud be upgrade to 3.2.1 [1] is not compatible with the actual 2.x series [2]. I have different packages which depend on 2.x (e.g. springframework-data-mongodb, latest release and snapshot depend on mongo-java-driver 2.14.1, not upgradable)


[1] http://www.spinics.net/linux/fedora/fedora-devel-java/msg05389.html
[2] http://mongodb.github.io/mongo-java-driver/3.0/whats-new/upgrading/
Comment 4 gil cattaneo 2016-01-27 16:50:28 EST
Spec URL: https://gil.fedorapeople.org/mongo-java-driver2.spec
SRPM URL: https://gil.fedorapeople.org/mongo-java-driver2-2.14.1-1.fc23.src.rpm
Description:
Java libraries to connect to the MongoDB document database.
Comment 5 Christos Triantafyllidis 2016-01-27 16:58:13 EST
I still think that should be discussed with the package maintainer first.

I'm CCing the package contacts for their point on that.

If the only option is to introduce to introduce a new package we can proceed with that approach.
Comment 6 gil cattaneo 2016-01-27 17:09:31 EST
(In reply to Christos Triantafyllidis from comment #5)
> I still think that should be discussed with the package maintainer first.

This is a compact package [1], such as for e.g. log4j12, lucene3/4
[1] https://fedorahosted.org/released/javapackages/doc/#compat_packages

> I'm CCing the package contacts for their point on that.
> 
> If the only option is to introduce to introduce a new package we can proceed
> with that approach.
as you want.

regards
Comment 7 Severin Gehwolf 2016-01-28 07:20:58 EST
(In reply to Christos Triantafyllidis from comment #5)
> I still think that should be discussed with the package maintainer first.
> 
> I'm CCing the package contacts for their point on that.
> 
> If the only option is to introduce to introduce a new package we can proceed
> with that approach.

I'm OK with a 2.x compat package and I've just pushed the 3.x update to rawhide[1].

[1] http://koji.fedoraproject.org/koji/taskinfo?taskID=12711384
Comment 8 Christos Triantafyllidis 2016-01-28 07:23:48 EST
Many thanks Severin,

I'll proceed with the review then.

Cheers,
Christos
Comment 9 Christos Triantafyllidis 2016-01-28 08:00:43 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "Apache (v2.0)", "Unknown or generated". 119
     files have unknown license. Detailed output of licensecheck in
     ~/1302003-mongo-java-driver2/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[?]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[!]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[?]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mongo-
     java-driver2-javadoc
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: mongo-java-driver2-2.14.1-1.fc24.noarch.rpm
          mongo-java-driver2-javadoc-2.14.1-1.fc24.noarch.rpm
          mongo-java-driver2-2.14.1-1.fc24.src.rpm
mongo-java-driver2.src:16: W: unversioned-explicit-provides bundle(apache-commons-codec)
mongo-java-driver2.src:18: W: unversioned-explicit-provides bundle(jcip-annotations)
mongo-java-driver2.src:20: W: unversioned-explicit-provides bundle(postgresql-jdbc)
3 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
mongo-java-driver2 (rpmlib, GLIBC filtered):
    java-headless
    jpackage-utils

mongo-java-driver2-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
mongo-java-driver2:
    bundle(apache-commons-codec)
    bundle(jcip-annotations)
    bundle(postgresql-jdbc)
    mongo-java-driver2
    mvn(org.mongodb:mongo-java-driver:2)
    mvn(org.mongodb:mongo-java-driver:2.14.1)
    mvn(org.mongodb:mongo-java-driver:pom:2)
    mvn(org.mongodb:mongo-java-driver:pom:2.14.1)
    osgi(org.mongodb.mongo-java-driver)

mongo-java-driver2-javadoc:
    mongo-java-driver2-javadoc



Source checksums
----------------
https://github.com/mongodb/mongo-java-driver/archive/r2.14.1.tar.gz :
  CHECKSUM(SHA256) this package     : b7ac7b11ceda6be41290d86fe339d14ac03fb05ac0299d03d6817e1b867d8a42
  CHECKSUM(SHA256) upstream package : b7ac7b11ceda6be41290d86fe339d14ac03fb05ac0299d03d6817e1b867d8a42


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1302003
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


The following are not blocking the review:
[!]: Latest version is packaged.
This is intended to be a compat package thus the latest 2.x version is packaged.
[!]: %check is present and all tests pass.
Clarified in the comment in the spec and confirmed that the original package doesn't include %check too

The following need to be addressed:
[?]: Package contains no bundled libraries without FPC exception.
While I don't see anything bundled, I see the following explicit provides:
- bundle(apache-commons-codec)
- bundle(jcip-annotations)
- bundle(postgresql-jdbc)
[?]: Final provides and requires are sane (see attachments).
Again the same provides as above, why are those explicitly defined? I don't see the original package to provide those.
[?]: Package functions as described.
I'm not sure how to test this. Would it be possible to provide a test case? I'd like to run a simple test run especially given the fact that %check is not included.
[!]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mongo-
     java-driver2-javadoc


I also see that compared to the original package the following subpackages are missing:
mongo-java-driver2-bson
mongo-java-driver2-bson-javadoc

Also another thing that is not clear to me is why the SPEC file of mongo-java-driver is not used as a base for this given that the aim of a compat package should be to have the exactly the same functionality as the initial one that got updated.
Comment 10 gil cattaneo 2016-01-28 08:14:05 EST
(In reply to Christos Triantafyllidis from comment #9)

> The following are not blocking the review:
> [!]: Latest version is packaged.
> This is intended to be a compat package thus the latest 2.x version is
> packaged.
> [!]: %check is present and all tests pass.
> Clarified in the comment in the spec and confirmed that the original package
> doesn't include %check too
> 
> The following need to be addressed:
> [?]: Package contains no bundled libraries without FPC exception.
> While I don't see anything bundled, I see the following explicit provides:
> - bundle(apache-commons-codec)
> - bundle(jcip-annotations)
> - bundle(postgresql-jdbc)

Those files are modifications of code included in:
apache-commons-codec src/main/com/mongodb/util/Base64Codec.java
jcip-annotations src/main/org/bson/util/annotations/*
postgresql-jdbc src/main/org/bson/io/UTF8Encoding.java
Now, is no more required ask an FPC exception if in the
spec file are explained the bundles libraries

> [?]: Final provides and requires are sane (see attachments).
> Again the same provides as above, why are those explicitly defined? I don't
> see the original package to provide those.
what packages?
> [?]: Package functions as described.
> I'm not sure how to test this. Would it be possible to provide a test case?
> I'd like to run a simple test run especially given the fact that %check is
> not included.
maven build style not use and do not need the %check section
> [!]: If package contains pom.xml files install it (including metadata) even
>      when building with ant
already installed using %mvn_install instruction
> [!]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mongo-
>      java-driver2-javadoc

No needed is a noarch package
> 
> I also see that compared to the original package the following subpackages
> are missing:
> mongo-java-driver2-bson
> mongo-java-driver2-bson-javadoc
not needed
> Also another thing that is not clear to me is why the SPEC file of
> mongo-java-driver is not used as a base for this given that the aim of a
> compat package should be to have the exactly the same functionality as the
> initial one that got updated.

It is not necessary
Comment 11 Christos Triantafyllidis 2016-01-28 08:35:04 EST
(In reply to gil cattaneo from comment #10)
> (In reply to Christos Triantafyllidis from comment #9)
> 
> > The following are not blocking the review:
> > [!]: Latest version is packaged.
> > This is intended to be a compat package thus the latest 2.x version is
> > packaged.
> > [!]: %check is present and all tests pass.
> > Clarified in the comment in the spec and confirmed that the original package
> > doesn't include %check too
> > 
> > The following need to be addressed:
> > [?]: Package contains no bundled libraries without FPC exception.
> > While I don't see anything bundled, I see the following explicit provides:
> > - bundle(apache-commons-codec)
> > - bundle(jcip-annotations)
> > - bundle(postgresql-jdbc)
> 
> Those files are modifications of code included in:
> apache-commons-codec src/main/com/mongodb/util/Base64Codec.java
> jcip-annotations src/main/org/bson/util/annotations/*
> postgresql-jdbc src/main/org/bson/io/UTF8Encoding.java
> Now, is no more required ask an FPC exception if in the
> spec file are explained the bundles libraries
> 
I missed that change in the guidelines. Confirmed!

> > [?]: Final provides and requires are sane (see attachments).
> > Again the same provides as above, why are those explicitly defined? I don't
> > see the original package to provide those.
> what packages?
I was referring to the current mongo-java-driver. Looks like that was a miss on the original package.

> > [?]: Package functions as described.
> > I'm not sure how to test this. Would it be possible to provide a test case?
> > I'd like to run a simple test run especially given the fact that %check is
> > not included.
> maven build style not use and do not need the %check section

I understand that this may not be used but I have no way to ensure that this package actually does what it is supposed to do. Is there a simple unit test I can use to cross-check it? If that requires mongo servers etc that is something that I cannot test.


> > [!]: If package contains pom.xml files install it (including metadata) even
> >      when building with ant
> already installed using %mvn_install instruction
Agreed!

> > [!]: Fully versioned dependency in subpackages if applicable.
> >      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mongo-
> >      java-driver2-javadoc
> 
> No needed is a noarch package

Not sure how the build arch relates to that. That more or less means that whenever the mongo-java-driver2-javadoc it should pull mongo-java-driver2 too.

> > 
> > I also see that compared to the original package the following subpackages
> > are missing:
> > mongo-java-driver2-bson
> > mongo-java-driver2-bson-javadoc
> not needed

Does this package provide also the bson package functionality? If not then it won't be a 100% compat package. Excuse the fact that I have minimal java knowledge, does that mean that no-one would ever need those bson subpackages?

> > Also another thing that is not clear to me is why the SPEC file of
> > mongo-java-driver is not used as a base for this given that the aim of a
> > compat package should be to have the exactly the same functionality as the
> > initial one that got updated.
> 
> It is not necessary
Yes but it would just make the SPEC preperation and the review much easier :)
Comment 12 gil cattaneo 2016-01-28 09:01:42 EST
(In reply to Christos Triantafyllidis from comment #11)
> (In reply to gil cattaneo from comment #10)
> > (In reply to Christos Triantafyllidis from comment #9)
> > > I'm not sure how to test this. Would it be possible to provide a test case?
> > > I'd like to run a simple test run especially given the fact that %check is
> > > not included.
> > maven build style not use and do not need the %check section
> 
> I understand that this may not be used but I have no way to ensure that this
> package actually does what it is supposed to do. Is there a simple unit test
> I can use to cross-check it? If that requires mongo servers etc that is
> something that I cannot test.

MongoDB stuff in this case is useless, we can't run test suite

> > > [!]: Fully versioned dependency in subpackages if applicable.
> > >      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mongo-
> > >      java-driver2-javadoc
> > 
> > No needed is a noarch package
> 
> Not sure how the build arch relates to that. That more or less means that
> whenever the mongo-java-driver2-javadoc it should pull mongo-java-driver2
> too.

Both packages are noarch. Why i should use ISA notation? No have sense for me

> > > 
> > > I also see that compared to the original package the following subpackages
> > > are missing:
> > > mongo-java-driver2-bson
> > > mongo-java-driver2-bson-javadoc
> > not needed
> 
> Does this package provide also the bson package functionality? If not then
> it won't be a 100% compat package. Excuse the fact that I have minimal java
> knowledge, does that mean that no-one would ever need those bson subpackages?

Original mongo-java-driver spec file use ant build style, and split the library in two artifacts. With maven both libraries are contained in the same JAR file
As compact package this work fine, for me.

> > > Also another thing that is not clear to me is why the SPEC file of
> > > mongo-java-driver is not used as a base for this given that the aim of a
> > > compat package should be to have the exactly the same functionality as the
> > > initial one that got updated.
> > 
> > It is not necessary
> Yes but it would just make the SPEC preperation and the review much easier :)
Comment 13 Christos Triantafyllidis 2016-01-28 09:12:38 EST
(In reply to gil cattaneo from comment #12)
> (In reply to Christos Triantafyllidis from comment #11)
> > (In reply to gil cattaneo from comment #10)
> > > (In reply to Christos Triantafyllidis from comment #9)
> > > > I'm not sure how to test this. Would it be possible to provide a test case?
> > > > I'd like to run a simple test run especially given the fact that %check is
> > > > not included.
> > > maven build style not use and do not need the %check section
> > 
> > I understand that this may not be used but I have no way to ensure that this
> > package actually does what it is supposed to do. Is there a simple unit test
> > I can use to cross-check it? If that requires mongo servers etc that is
> > something that I cannot test.
> 
> MongoDB stuff in this case is useless, we can't run test suite

Agreed.

> 
> > > > [!]: Fully versioned dependency in subpackages if applicable.
> > > >      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mongo-
> > > >      java-driver2-javadoc
> > > 
> > > No needed is a noarch package
> > 
> > Not sure how the build arch relates to that. That more or less means that
> > whenever the mongo-java-driver2-javadoc it should pull mongo-java-driver2
> > too.
> 
> Both packages are noarch. Why i should use ISA notation? No have sense for me
> 
The ISA notation is not the point here. The point was that mongo-java-driver2-javadoc doesn't have mongo-java-driver2 in its requires. I checked again the mongo-java-driver-javadoc and I see that this is not the case for it too so we can skip that too.

> > > > 
> > > > I also see that compared to the original package the following subpackages
> > > > are missing:
> > > > mongo-java-driver2-bson
> > > > mongo-java-driver2-bson-javadoc
> > > not needed
> > 
> > Does this package provide also the bson package functionality? If not then
> > it won't be a 100% compat package. Excuse the fact that I have minimal java
> > knowledge, does that mean that no-one would ever need those bson subpackages?
> 
> Original mongo-java-driver spec file use ant build style, and split the
> library in two artifacts. With maven both libraries are contained in the
> same JAR file
> As compact package this work fine, for me.
> 

Agreed. Thanks for clarifying.

I'm marking the review as completed.
Comment 14 gil cattaneo 2016-01-28 09:39:04 EST
Thanks!

Request for new package
https://admin.fedoraproject.org/pkgdb/package/requests/3561
Comment 15 gil cattaneo 2016-01-29 09:34:24 EST
Request for new package
https://admin.fedoraproject.org/pkgdb/package/requests/3576
Comment 16 gil cattaneo 2016-01-29 09:44:38 EST
Request for new package
https://admin.fedoraproject.org/pkgdb/package/requests/3577
Comment 17 Gwyn Ciesla 2016-01-29 10:16:50 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/mongo-java-driver2
Comment 18 gil cattaneo 2016-01-29 11:02:14 EST
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=12727020

Note You need to log in before you can comment on or make changes to this bug.